<?php

header('Access-Control-Allow-Origin:*');
header("Content-type:text/html;charset=utf-8");
require_once('WxPay.Api.php');
require_once('WxPay.JsApiPay.php');
require_once('WxPay.Config.php');

class index{

	/* *
	*	构造
	* * * * *
	*/
	public function __construct(){
	}


	/* *
	*	获取用户openid
	* * * * *
	*/
	public function wx_pay(){
		$tools = new JsApiPay();
		$openId = $tools->GetOpenid();
		if($openId){
			setcookie("openid", $openId);
			header("Location:http://xxx.xxx.com/xxx.html");
		}
	}


	/* *
	*	支付完成后跳转的页面
	* * * * *
	*/
	public function wx_pay_finish_page(){
		//在此构建支付完成后的逻辑与页面
	}


	/* *
	*	创建微信jsapi支付请求
	* * * * *
	*/
	public function create_wx_jsapi_pay_request($request_info = ''){
		$status = 0;
		$msg = '';
		$request_str = '';
		try{
			#获取用户openid
			$openid = $_COOKIE['openid'];
			#统一下单
			$wx = new WxPayUnifiedOrder();
			$wx->SetBody("微信jsapi支付测试"); //商品描述
			$wx->SetOut_trade_no("sdkphp".date("YmdHis")); //商户订单号
			$wx->SetTotal_fee("1"); //标价金额
			$wx->SetTime_start(date("YmdHis")); //交易起始时间，选填
			$wx->SetTime_expire(date("YmdHis", time() + 600)); //交易结束时间，选填
			$wx->SetGoods_tag("test"); //订单优惠标记，选填
			$wx->SetNotify_url("http://xxx.xxx.com/wx_notify.php"); //回调地址
			$wx->SetTrade_type("JSAPI");
			$wx->SetOpenid($openid);
			#获取参数
			$config = new WxPayConfig();
			$order = WxPayApi::unifiedOrder($config, $wx);
			$tools = new JsApiPay();
			$request_str = $tools->GetJsApiParameters($order);
		} catch(Exception $e) {
			$status = "-1";
			$msg = $e->getMessage();
		}

		END:
		$result_info = array(
			'status'	=>	$status,
			'msg'		=>	$msg,
			'data'		=>	$request_str,
		);
		echo json_encode($result_info);
	}


	/* *
	*	微信jsapi支付 回调
	*   
	* * * * *
	*/
	public function wx_notify(){
		$log_address = './log/';	//日志存储路径，目录下包含error目录，所有目录必须可写
		$xmlData = file_get_contents('php://input'); //接收微信返回的数据数据,返回的xml格式
		$filename = date('Ymd', time()).".txt";
		if ($xmlData == '') {
			$file = fopen($log_address.'error/'.$filename, 'a+');
			fwrite($file, "错误信息：未接收到参数\r\n");
		}
		//将xml格式转换为数组
		$data = FromXml($xmlData);
		//用日志记录检查数据是否接受成功，验证成功一次之后，可删除。
		/******/
		$file = fopen($log_address.$filename, 'a+');
		fwrite($file, var_export($data, true));		//这个日志包含微信返回的所有参数！！！
		echo '<xml><return_code><![CDATA[SUCCESS]]></return_code><return_msg><![CDATA[OK]]></return_msg></xml>';
		exit;
	}


	/* *
	*	Xml转数组
	*   
	* * * * *
	*/
	public function FromXml($xml){
		if(!$xml){
			echo "xml数据异常！";
		}
		//将XML转为array
		//禁止引用外部xml实体
		libxml_disable_entity_loader(true);
		$data = json_decode(json_encode(simplexml_load_string($xml, 'SimpleXMLElement', LIBXML_NOCDATA)), true);
		return $data;
	}



	/* *
	*	签名
	*   
	* * * * *
	*/
	function get_jsapi_Sign(){
		$appid = "";
		$mch_id = "";
		$nonce_str = "";
		$key = "";
		$stringA="appid=$appid&mch_id=$mch_id&nonce_str=$nonce_str";
		$stringSignTemp = $stringA.$key;
		$sign = strtoupper(hash_hmac("sha256", $string, $key));
		return $sign;
	}



}

?>